petsc-3.10.5 2019-03-28
Report Typos and Errors

# PetscOptionsFList

Puts a list of option values that a single one may be selected from

### Synopsis

    #include "petscsys.h"
    PetscErrorCode  PetscOptionsFList_Private(PetscOptionItems *PetscOptionsObject,const char opt[],const char ltext[],const char man[],PetscFunctionList list,const char currentvalue[],char value[],size_t len,PetscBool  *set)

Logically Collective on the communicator passed in PetscOptionsBegin()

### Input Parameters

| opt | - option name
| text | - short string that describes the option
| man | - manual page with additional information on option
| list | - the possible choices
| currentvalue | - the current value; caller is responsible for setting this value correctly. Normally this is done with

                    PetscOptionsFlist(..., obj->value,value,len,&flg);

                    if (flg) {

| len | - the length of the character array value

### Output Parameter

| value | - the value to return
| set | - PETSC_TRUE if found, else PETSC_FALSE

### Notes

Must be between a PetscOptionsBegin() and a PetscOptionsEnd()

If the user does not supply the option at all value is NOT changed. Thus you should ALWAYS initialize value if you access it without first checking if the set flag is true.

The default/currentvalue passed into this routine does not get transferred to the output value variable automatically.

See PetscOptionsEList() for when the choices are given in a string array

To get a listing of all currently specified options, see PetscOptionsView() or PetscOptionsGetAll()

Developer Note: This cannot check for invalid selection because of things like MATAIJ that are not included in the list

### See Also

PetscOptionsGetInt(NULL,), PetscOptionsGetReal(),
PetscOptionsHasName(), PetscOptionsGetIntArray(), PetscOptionsGetRealArray(), PetscOptionsBool(), PetscOptionsName(), PetscOptionsBegin(), PetscOptionsEnd(), PetscOptionsHead(), PetscOptionsStringArray(),PetscOptionsRealArray(), PetscOptionsScalar(), PetscOptionsBoolGroupBegin(), PetscOptionsBoolGroup(), PetscOptionsBoolGroupEnd(), PetscOptionsFList(), PetscOptionsEList(), PetscOptionsEnum()

### Level

intermediate

### Location

src/sys/objects/aoptions.c

### Examples

src/dm/field/examples/tutorials/ex1.c.html
src/ksp/ksp/examples/tutorials/ex18.c.html
src/snes/examples/tutorials/ex12.c.html
src/snes/examples/tutorials/ex48.c.html
src/snes/examples/tutorials/ex56.c.html
src/ts/examples/tutorials/ex8.c.html
src/ts/examples/tutorials/ex9.c.html
src/ts/examples/tutorials/ex11.c.html
src/ts/examples/tutorials/ex14.c.html
src/ts/examples/tutorials/ex48.c.html
Index of all Sys routines
Table of Contents for all manual pages
Index of all manual pages